# encoding: utf-8

import es, gamethread, playerlib, langlib, time
#import sqlite3 as sql 

messages = langlib.Strings(es.getAddonPath("survivalbotf") + "/translations.ini")

# On ajoute quelques infos à afficher lorsqu'un utilisateur tape 'es_load' dans la console
info = es.AddonInfo()
info.name = 'survivalbotf' # nom du script
info.version = '1.0.0' # version
info.author = 'Fantole' # auteur
info.url = 'http://mattie.info/forums/' # lien où le script peut être trouvé
info.description = 'Survivre à une invasion de BOT' # description courte
info.tags = 'survie,fantole,survival,bot,train awp' # mots clés

def load():
    es.sql("open", "datasql", "|survivalbotf/data")
    es.sql("query","datasql", "CREATE TABLE IF NOT EXISTS players(steamid VARCHAR(20) UNIQUE NOT NULL, kills INT(3) DEFAULT 0, deaths INT(3) DEFAULT 0, lastconnexion VARCHAR(16) DEFAULT 0)")
    
    global survivalbotf_temp
    global survivalbotf_temp2
    global survivalbotf_health
    global survivalbotf_addhealth
    global survivalbotf_limithealth
    global survivalbotf_objectif
    global survivalbotf_deathmatch
    global survivalbotf_timespawn
    global survivalbotf_autoweapon
    global survivalbotf_autoaccessory
    global survivalbotf_autocash
    global survivalbotf_kitaccessoirebot
    global survivalbotf_checkbot
    global survivalbotf_playerweapon
    
    es.ServerVar('survivalbotf_version', info.version, 'Version du script survivalbotf').makepublic()
    survivalbotf_temp = es.ServerVar('survivalbotf_temp', 0, "survivalbotf : Variable a contenu temporaire")
    survivalbotf_temp2 = es.ServerVar('survivalbotf_temp2', 0, "survivalbotf : Variable a contenu temporaire")
    survivalbotf_health = es.ServerVar('survivalbotf_health', 0, "survivalbotf : Sert a stoquer le nombre de HP des joueurs")
    survivalbotf_addhealth = es.ServerVar('survivalbotf_addhealth', 0, "survivalbotf : Nombre de HP que gagne le joueur en tuant un BOT si il ne depasse pas la limite fixee par la variable survivalbotf_limithealth")
    survivalbotf_limithealth = es.ServerVar('survivalbotf_limithealth', 0, "survivalbotf : Seuil limite des HP des joueurs")
    survivalbotf_objectif = es.ServerVar('survivalbotf_objectif', 0, "survivalbotf : 1 = Activer les objectifs de MAP, 0 Desactiver")
    survivalbotf_deathmatch = es.ServerVar('survivalbotf_deathmatch', 0, "survivalbotf : 1 = Activer le mode Death-Match, les joueurs renaissent, 0 = Desactiver")
    survivalbotf_timespawn = es.ServerVar('survivalbotf_timespawn', 0, "survivalbotf : Temps en secondes avant qu'un joueur ne puisse reanaitre, necessite que la variable survivalbotf_deathmatch soit a 1")
    survivalbotf_autoweapon = es.ServerVar('survivalbotf_autoweapon', 0, "survivalbotf : Armes que les joueurs humains recoivent en joignant l'equipe des humains")
    survivalbotf_autoaccessory = es.ServerVar('survivalbotf_autoaccessory', 0, "survivalbotf : Accessoires que les joueurs humains recoivent en joignant l'equipe des humains")
    survivalbotf_autocash = es.ServerVar('survivalbotf_autocash', 0, "survivalbotf : Montant en dollard que les joueurs recoivent en debut de round")
    survivalbotf_kitaccessoirebot = es.ServerVar('survivalbotf_kitaccessoirebot', 0, "survivalbotf : 1 = Activer l'auto assignement d'accessoires aux BOT, 0 Desactiver")
    survivalbotf_checkbot = es.ServerVar('survivalbotf_checkbot', 0, "survivalbotf : Variable a contenu temporaire")
    survivalbotf_playerweapon = es.ServerVar('survivalbotf_playerweapon', 0, "survivalbotf : Permettre aux joueur de choisir de ne pas recevoir les armes automatiquements, 0 = Désactiver, 1 = Activer")

    es.msg('#multi', '#lightgreen[Survival BOT]#lightgreen ON')

    es.mexec('../addons/eventscripts/survivalbotf/cfg/config_script.cfg')
    es.mexec('../addons/eventscripts/survivalbotf/cfg/config_server.cfg')
        
    es.mexec('../addons/eventscripts/survivalbotf/cfg/config_bot.cfg')

def player_activate(event_var):
    if event_var['es_steamid'] != "BOT":
        exist = es.sql('queryvalue','datasql',"SELECT steamid FROM players WHERE steamid ='%s'" % event_var['es_steamid'])
        if exist:
            es.sql('query','datasql',"UPDATE players SET lastconnexion = '%s' WHERE steamid ='%s'" % (time.strftime('%d/%m/%y %H:%M',time.localtime()), event_var['es_steamid']))

        else:
            es.sql('query','datasql',"INSERT INTO players ('steamid', 'kills', 'deaths', 'lastconnexion') VALUES ('%s', '0', '0', '%s')" % (event_var['es_steamid'],time.strftime('%d/%m/%y %H:%M',time.localtime())))


def es_map_start(event_var):
    gamethread.cancelDelayed('respawn')
    gamethread.cancelDelayed('remove_weapon')
    gamethread.cancelDelayed('remove_ragdoll')
    gamethread.cancelDelayed('god_off')

def unload():
    es.msg('#multi', '#lightgreen[Survival BOT]#lightgreen OFF')
    es.sql("close", "datasql")
    
    es.server.queuecmd('bot_kick')
    gamethread.cancelDelayed('respawn')
    gamethread.cancelDelayed('remove_weapon')
    gamethread.cancelDelayed('remove_ragdoll')
    gamethread.cancelDelayed('god_off')

def bomb_pickup(event_var):
    if int(survivalbotf_objectif) == 0:
        es.server.queuecmd('est_removeweapon %s weapon_c4' % event_var['userid'])

def round_start(event_var):
    global finround
    finround = "non"

    if int(survivalbotf_objectif) == 0:
        if "cs_" in str(es.ServerVar('eventscripts_currentmap')):
          es.server.queuecmd('est_remove hostage_entity')
    for userid in playerlib.getUseridList("#human"):
        joueur = playerlib.getPlayer(userid)
        es.tell(userid, '#multi', '#lightgreen[Survival BOT]#default %s' % messages("welcome",lang=joueur.get("lang")))
        es.tell(userid, '#multi', '#lightgreen[Survival BOT]#green %s #default!stat' % messages("commande",lang=joueur.get("lang")))

def round_end(event_var):
    global finround
    finround = "oui"
    gamethread.cancelDelayed('respawn')
    gamethread.cancelDelayed('remove_weapon')
    gamethread.cancelDelayed('remove_ragdoll')
    gamethread.cancelDelayed('god_off')

def player_spawn(event_var):
    userid = event_var['userid']
    es_userteam = event_var['es_userteam']
    joueur = playerlib.getPlayer(userid)
    
    if str(survivalbotf_autoweapon) != "" and str(survivalbotf_autoweapon) != "0,0":
        steamid = es.getplayersteamid(userid)

        if str(steamid) != "BOT":
            auto_weapon(userid, es_userteam)

            if str(survivalbotf_autoaccessory) != "" and str(survivalbotf_autoaccessory) != "0,0,0,0,0,0,0":
                auto_equipement(userid)

    if int(survivalbotf_autocash) != 0:
        argent(userid)

    if int(survivalbotf_kitaccessoirebot) == 1:
        kitbot(userid)

def kitbot(userid):
    steamid = es.getplayersteamid(userid)
    
    if str(steamid) == "BOT":
        es.server.queuecmd('es_xcexec %s buy weapon_hegrenade' % int(userid))
        es.server.queuecmd('es_xcexec %s buy weapon_flashbang' % int(userid))
        es.server.queuecmd('es_xcexec %s buy weapon_smokegrenade' % int(userid))
        

def auto_equipement(userid):
    autoEquipements = str(survivalbotf_autoaccessory).split(",")
    global equipement
    for equipement in autoEquipements:
        auto_equipement2(userid, equipement)

def auto_equipement2(userid, equipement):    
    es.server.queuecmd('es_xcexec %s buy %s' % (int(userid), str(equipement)))

def auto_weapon(userid, es_userteam):
    
    if int(es_userteam) != 0 and int(es_userteam) != 1:
           
        if es.ServerVar('mp_humanteam') == "ct":                        
            equipement = str(survivalbotf_autoweapon).split(",")

            for equipement in autoEquipements:
                es.server.queuecmd('es_xcexec %s buy weapon_%s' % (int(userid), str(equipement)))

        if es.ServerVar('mp_humanteam') == "t":
            autoEquipements = str(survivalbotf_autoweapon).split(",")

            for equipement in autoEquipements:
                es.server.queuecmd('es_xcexec %s buy weapon_%s' % (int(userid), str(equipement)))

def argent(userid):
    joueur = playerlib.getPlayer(userid)
    joueur.set("cash", int(survivalbotf_autocash))

def player_death(event_var):
    userid = event_var['userid']
    attacker = event_var['attacker']
    joueur = playerlib.getPlayer(attacker)

    if es.ServerVar('mp_humanteam') == "ct":
        
        if int(event_var['es_userteam']) == 2 and int(survivalbotf_addhealth) != 0:
            
            if int(userid) != int(attacker):
                survivalbotf_health = joueur.get("health")
                
                if int(survivalbotf_health) < int(survivalbotf_limithealth):
                    survivalbotf_health = survivalbotf_health + survivalbotf_addhealth
                    joueur.set("health", int(survivalbotf_health))
                    es.server.queuecmd('es_xplaysound %s buttons/bell1.wav 1.0' % attacker)
                    es.centermsg('%s + %s HP' % (event_var['es_attackername'], int(survivalbotf_addhealth)))
                    es.tell(attacker, '#multi', "#green%s + #lightgreen%s" % (messages("vie",lang=joueur.get("lang")), int(survivalbotf_addhealth)))
                    
                joueur.set("health", int(survivalbotf_health))
                if int(survivalbotf_health) > int(survivalbotf_limithealth):
                    joueur.set("health", int(survivalbotf_limithealth))
            
        if int(event_var['es_userteam']) == 3:
            es.server.queuecmd('es_xplaysound %s weapons/debris2.wav 1.0' % userid)
            es.tell(userid, '#multi', '#lightgreen%s #green %s' % (messages("gameover",lang=joueur.get("lang"))), event_var['es_username'])
            
    if str(es.ServerVar('mp_humanteam')) == "t":
        
        if int(event_var['es_userteam']) == 3 and int(survivalbotf_addhealth) != 0:
            
            if int(userid) != int(attacker) and int(event_var['es_userteam'] != int(event_var['es_attackerteam'])):
                survivalbotf_health = joueur.get("health")

                if int(survivalbotf_health) < int(survivalbotf_limithealth):
                    survivalbotf_health = survivalbotf_health + survivalbotf_addhealth
                    joueur.set("health", int(survivalbotf_health))
                    es.server.queuecmd('es_xplaysound %s buttons/bell1.wav 1.0' % attacker)
                    es.centermsg('%s + %s HP' % (event_var['es_attackername'], int(survivalbotf_addhealth)))
                    es.tell(attacker, '#multi', "#green%s + #lightgreen%s" % (messages("vie",lang=joueur.get("lang")), int(survivalbotf_addhealth)))
                    
                survivalbotf_health = joueur.get("health")
                if int(survivalbotf_health) > int(survivalbotf_limithealth):
                    joueur.set("health", int(survivalbotf_limithealth))

        if int(event_var['es_userteam']) == 2:
            es.server.queuecmd('es_xplaysound %s weapons/debris2.wav 1.0' % userid)
            es.tell(userid, '#multi', '#lightgreen%s #green%s' % (messages("gameover",lang=joueur.get("lang")), str(event_var['es_username'])))

    gamethread.delayedname(0.1, 'check_roundend', check_roundend, (userid))

def check_roundend(userid):
    joueur = playerlib.getPlayer(userid)
    if int(survivalbotf_deathmatch) == 1 and str(finround) == "non":
        es.tell(userid, '#multi', '#green%s %s %s' % (messages("respawn1",lang=joueur.get("lang")), int(survivalbotf_timespawn), messages("respawn2",lang=joueur.get("lang"))))
        gamethread.delayedname(int(survivalbotf_timespawn), 'respawn', respawn, (userid))
        gamethread.delayedname(10, 'remove_weapon', remove_weapon, ("est_removeidle weapon", "es_xremove item_defuser", userid))
        gamethread.delayedname(int(survivalbotf_timespawn), 'remove_ragdoll', remove_ragdoll, ("est_deleteragdolls"))

    if int(survivalbotf_deathmatch) == 1 and str(finround) == "oui":
        gamethread.cancelDelayed('respawn')
        gamethread.cancelDelayed('remove_weapon')
        gamethread.cancelDelayed('remove_ragdoll')
        gamethread.cancelDelayed('god_off')

def respawn(userid):
    joueur = playerlib.getPlayer(userid)
    es.server.cmd('est_spawn %s' % userid)
    es.server.cmd('est_god %s 1' % userid)
    joueur.set("color", [255, 0, 0, 255])
    gamethread.delayedname(5, 'god_off', god_off, (userid))

def remove_weapon(action,action2,userid):
    user_team = es.getplayerteam(userid)
    es.server.queuecmd(action)
    if int(user_team) == 3:
        es.server.queuecmd(action2)

def remove_ragdoll(action):
    es.server.queuecmd(action)

def god_off(userid):
    joueur = playerlib.getPlayer(userid)
    es.server.cmd('est_god %s 0' % userid)
    joueur.set("color", [255, 255, 255, 255])      

def player_team(event_var):
    if event_var['team'] != "0":
        userid = event_var['userid']
        joueur = playerlib.getPlayer(userid)
        dead = joueur.get("isdead")
        steamid = es.getplayersteamid(userid)
        user_team = es.getplayerteam(userid)
        if str(steamid) != "BOT" and int(user_team) != 0 and int(user_team) != 1 and int(dead) == 1:
            es.tell(event_var['userid'], '#multi', '#green%s %s %s' % (messages("respawn1",lang=joueur.get("lang")), int(survivalbotf_timespawn), messages("respawn2",lang=joueur.get("lang"))))
            gamethread.delayedname(int(survivalbotf_timespawn), 'respawn', respawn, (userid)) 

def player_say(event_var):
    if event_var['text'] == "!stat":
        userid = event_var['userid']
        joueur = playerlib.getPlayer(userid)
        lastconnexion = es.sql('queryvalue','datasql',"SELECT lastconnexion FROM players WHERE steamid ='%s'" % event_var['es_steamid'])
        if str(lastconnexion) != "" and str(lastconnexion) != "0":
            kills = es.sql('queryvalue','datasql',"SELECT kills FROM players WHERE steamid ='%s'" % event_var['es_steamid'])
            deaths = es.sql('queryvalue','datasql',"SELECT deaths FROM players WHERE steamid ='%s'" % event_var['es_steamid'])
            if kills != "" and kills != "0" and kills != "None" and deaths != "" and deaths != "0" and deaths != "None":
                es.menu(10, event_var['userid'], '%s = %s\\n%s = %s\\n\\n%s :\\n%s = %s\\n%s = %s\\n%s = %s"' % (messages("steamid",lang=joueur.get("lang")), event_var['es_steamid'], messages("lastconnexion",lang=joueur.get("lang")), str(lastconnexion), messages("bestscore",lang=joueur.get("lang")), messages("kills",lang=joueur.get("lang")), int(kills), messages("deaths",lang=joueur.get("lang")), int(deaths), messages("ratio",lang=joueur.get("lang")), float(kills)/float(deaths)))
            else:
                es.tell(event_var['userid'], '#multi', '#green%s' % messages("nosave",lang=joueur.get("lang")))
        else:
            es.tell(event_var['userid'], '#multi', '#green%s' % messages("erreursql",lang=joueur.get("lang")))

    if event_var['text'] == "!save":
        userid = event_var['userid']
        steamid = event_var['es_steamid']
        joueur = playerlib.getPlayer(userid)
        kills = joueur.attributes['kills']
        deaths = joueur.attributes['deaths']
        try:
            es.sql('query','datasql',"UPDATE players SET lastconnexion = '%s', kills = '%s', deaths = '%s' WHERE steamid ='%s'" % (time.strftime('%d/%m/%y %H:%M',time.localtime()), int(kills), int(deaths), str(steamid)))
            
        except Exception, err:
            print "[Survival BOT] Erreur rencontrée : %s" % err
            es.tell(userid, '#multi', '#lightgreen[Survival BOT]#green ERROR : %s' % err)

        else:
            es.tell(userid, '#multi', '#lightgreen[Survival BOT]#green %s' % messages("save",lang=joueur.get("lang")))
